C  --------------------------------------------------------------------
      SUBROUTINE MCT_Fit (ifuext, P, nf, XF, YF, Fehler)
C  --------------------------------------------------------------------

      IMPLICIT NONE
      INCLUDE 'i_dim.f'  
      INCLUDE 'l_def.f'

      INTEGER       MCO, MBL, MSV, ifu, ideb, ifuext, nf, if, is, it, i2,
     *              nBL, nCh, nC4, id, nd, ii, jcout, jfout, n1, nn
      PARAMETER    (MCO=2,MBL=MC,MSV=1024*1024)
      REAL*8        P(*), XF(*), YF(*), AX(MBL), Psi(MBL,MCO),
     *              Phi(MBL,MCO), Ern(MBL,MCO), dPhi(MBL,MCO), dErn(MBL,MCO), 
     *              SavX(MSV), SavY(MSV), Fric(MCO), Omeg(2), falt1, falt2,
     *              RedF(MCO), RedO(MCO), AuxA(MCO), AuxB(MCO), AuxC(MCO),
     *              lambda, epsilon, V1sq, V1li, V12, ph1A, ph1B, ph2A, ph2B,
     *              ht, sub1, sub2, sub3, sub4, genau, Amp, GaussW,
     *              Phinfty, Phigma, sumY, alpha, theta, delta, twopi
      CHARACTER     Fehler*(*), aux*20
      COMMON / MathConst / twopi

      IF (Fehler.ne.'&ff') RETURN 

C  Parameter :
      nd      = idnint (P(1)) ! # Dezimierungen
      nC4     = idnint (P(2)) ! 1/2 blocksize
      genau   = P(3)
      ht      = P(4) ! Startwert: wird beim Dezimieren jeweils verdoppelt
      Omeg(1) = P(5)
      Omeg(2) = P(6) 
      Fric(1) = P(7)
      Fric(2) = P(8)
      ! F12-Modell-spezifisch
      V1sq    = dmax1 (0.d0, P(10))
      V1li    = dmax1 (0.d0, P(9))
      V12     = dmax1 (0.d0, P(11))
      ideb    = idnint (P(12)) ! Debug ?
      Amp     = P(13)
      GaussW  = P(14)

C  Funktionsauswahl :
      IF (ideb.ge.1) THEN 
         ifu = ideb
      ELSE
         ifu = ifuext
         ENDIF
      IF     (ifu.eq.1) THEN 
         jcout = 1
         jfout = 1
      ELSEIF (ifu.eq.2) THEN
         jcout = 2
         jfout = 1
      ELSEIF (ifu.eq.3) THEN
         jcout = 1
         jfout = 2
      ELSEIF (ifu.eq.4) THEN
         jcout = 2
         jfout = 2
      ELSEIF (ifu.eq.5) THEN
         jcout = 1
         jfout = 3
      ELSEIF (ifu.eq.6) THEN
         jcout = 2
         jfout = 3
      ELSEIF (ifu.eq.7) THEN
         jcout = 1
         jfout = 4
      ELSEIF (ifu.eq.8) THEN
         jcout = 2
         jfout = 4
      ELSE 
         Fehler = 'MCT/ few-corr-models/ funtion not implemented'
         RETURN
         ENDIF

C  "Ubernahme der MCT-Parameter :
      ! Numerik-Setup :
      nBL     = 2 * nC4 + 1
      nCh     = 4 * nC4 + 1
      IF (nCh.gt.MBL) THEN 
         Fehler = 'MCT/ too much work space required'
         RETURN 
         ENDIF 
      IF ((nd+2)*2*nC4+1.gt.MSV) THEN
         Fehler = 'MCT/ too much internal storage required'
         RETURN 
         ENDIF 
      ! Modell :
      IF (Omeg(1).le.0 .or. Omeg(2).le.0) THEN 
         Fehler = 'Invalid Omega .le. 0'
         RETURN
         ENDIF 

C  Integration im Zeitraum
      ! Anfangswerte fuer t=0 :
      Phi(1,1) = 1
      Phi(1,2) = 1
      Ern(1,1) = V1li * Phi(1,1) + V1sq * Phi(1,1)**2        ! Sjoegren-Modell
      Ern(1,2) = V12  * Phi(1,1) * Phi(1,2)

      ! "startwerte"
      sub1= 1 - Fric(1)*ht
      sub2= Omeg(1)**2 * ht
      sub3= 1 - Fric(2)*ht
      sub4= Omeg(2)**2 * ht
      falt1=0
      falt2=0
      DO is = 1, nCh
         AX(is) = (is-1)*ht
         ENDDO 
      DO is = 2, nBL
         Psi(is,1) = sub1*Psi(is-1,1) - sub2*Phi(is-1,1) - sub2*falt1
         Psi(is,2) = sub3*Psi(is-1,2) - sub4*Phi(is-1,2) - sub4*falt2
         Phi(is,1) = ht*Psi(is,1)+Phi(is-1,1)
         Phi(is,2) = ht*Psi(is,2)+Phi(is-1,2)
         Ern(is,1) = V1li * Phi(is,1) + V1sq * Phi(is,1)**2
         Ern(is,2) = V12  * Phi(is,1) * Phi(is,2)
         falt1 = 0                    
         falt2 = 0   
         DO it = 1, is-1
            falt1 = falt1 + ht/2 *
     *              (Ern(1+is-it,1)*Psi(it,1) + Ern(is-it,1)*Psi(it+1,1))
            falt2 = falt2 + ht/2*
     *              (Ern(1+is-it,2)*Psi(it,2) + Ern(is-it,2)*Psi(it+1,2))
            ENDDO 
         ENDDO 
      ! "initialisiere"
      DO is = 2, nBL
         dPhi(is,1) = (Phi(is-1,1) + Phi(is,1)) / 2 ! schon durch ht geteilt
         dErn(is,1) = (Ern(is-1,1) + Ern(is,1)) / 2
         dPhi(is,2) = (Phi(is-1,2) + Phi(is,2)) / 2
         dErn(is,2) = (Ern(is-1,2) + Ern(is,2)) / 2
         ENDDO 
cdeb      Print *, ' DEB ', Psi(3,1), Phi(3,1), Ern(3,1)

      ! Speichern :
      DO is = 1, nBL ! sozusagen id=0
         SavX(is) = AX(is)
         SavY(is) = Phi(is,jcout)
         ENDDO 

      ! Hauptschleife:
      id = 1
 100  CONTINUE 
         ! "hauptalgorithmus"
         RedF(1) = 0.5*Fric(1) / ht / Omeg(1)**2
         RedF(2) = 0.5*Fric(2) / ht / Omeg(2)**2
         RedO(1) = 1.d0 / ht**2 / Omeg(1)**2
         RedO(2) = 1.d0 / ht**2 / Omeg(2)**2
         AuxA(1) = 1 + dErn(2,1) + 3*RedF(1) + 2*RedO(1)
         AuxA(2) = 1 + dErn(2,2) + 3*RedF(2) + 2*RedO(2)
         IF (AuxA(1).eq.0 .or. AuxA(2).eq.0) THEN 
            Fehler = 'unexpectedly AuxA=0 --> division by 0 imminent'
            RETURN
            ENDIF 
         AuxB(1) = (1 - dPhi(2,1)) / AuxA(1)
         AuxB(2) = (1 - dPhi(2,2)) / AuxA(2) ! war zeitweise AuxA(1) !??
         DO is = nBL+1, nCh
            Phi(is,1) = 0
            Ern(is,1) = 0
            Phi(is,2) = 0
            Ern(is,2) = 0
            ! Faltungsintegral :
            i2 = (is+1)/2
            AuxC(1) = Ern(i2,1) * Phi(1+is-i2,1)
            AuxC(2) = Ern(i2,2) * Phi(1+is-i2,2)
            DO it = 2, i2
               AuxC(1) = AuxC(1) +
     *              dErn(it,1) * (Phi(2+is-it,1) - Phi(1+is-it,1)) +
     *              dPhi(it,1) * (Ern(2+is-it,1) - Ern(1+is-it,1))
               AuxC(2) = AuxC(2) +
     *              dErn(it,2) * (Phi(2+is-it,2) - Phi(1+is-it,2)) +
     *              dPhi(it,2) * (Ern(2+is-it,2) - Ern(1+is-it,2))
               ENDDO ! it
            DO it = i2+1, is-i2+1
               AuxC(1) = AuxC(1) +
     *              dPhi(it,1) * (Ern(2+is-it,1) - Ern(1+is-it,1))
               AuxC(2) = AuxC(2) +
     *              dPhi(it,2) * (Ern(2+is-it,2) - Ern(1+is-it,2))
               ENDDO ! it
            AuxC(1) = AuxC(1) +
     *              RedO(1) * (-5*Phi(is-1,1)+4*Phi(is-2,1)-Phi(is-3,1)) +
     *              RedF(1) * (-4*Phi(is-1,1)+  Phi(is-2,1))
            AuxC(2) = AuxC(2) +                     
     *              RedO(2) * (-5*Phi(is-1,2)+4*Phi(is-2,2)-Phi(is-3,2)) +
     *              RedF(2) * (-4*Phi(is-1,2)+  Phi(is-2,2))
            AuxC(1) = AuxC(1) / AuxA(1)
            AuxC(2) = AuxC(2) / AuxA(2)


            ! Jetzt die Iteration (im Sjoegren-Modell hintereinander moeglich)
            ! ---> innerste Schleife (bottleneck) <--- !
            ! Zuerst Korrelator 1:
            ph1B = Phi(is-1,1)
 102        ph1A = ph1B
            ph1B = -AuxC(1) + AuxB(1) *
     *           ( V1li * ph1A + V1sq * ph1A**2 )
            IF (dabs(ph1B-ph1A).gt.genau) GOTO 102


            ! Dann Korrelator 2:
            ph2B = Phi(is-1,2)
 104        ph2A = ph2B
            ph2B = -AuxC(2) + AuxB(2) * ( V12 * ph1B * ph2A )
            IF (dabs(ph2B-ph2A).gt.genau) GOTO 104

            ! Ergebnis :
            Phi(is,1) = ph1B
            Phi(is,2) = ph2B
            Ern(is,1) = V1li * ph1B + V1sq * ph1B**2        ! Sjoegren-Modell
            Ern(is,2) = V12 * ph1B * ph2B
            ENDDO ! is

         ! "speichere" 
         DO is = nBL+1, nCh ! fuer id=1..nd
            SavX((id-1)*(nBL-1)+is) = AX(is)
            SavY((id-1)*(nBL-1)+is) = Phi(is,jcout)
            ENDDO 

         ! "dezimierungen"
         IF (id.gt.nd) GOTO 199
         ht = 2*ht
         DO is = 2, nCh
            AX(is) = (is-1) * ht
            ENDDO 
         DO is = 2, nC4+1
            dPhi(is,1) = (dPhi(2*is-2,1) + dPhi(2*is-1,1)) / 2
            dErn(is,1) = (dErn(2*is-2,1) + dErn(2*is-1,1)) / 2
            dPhi(is,2) = (dPhi(2*is-2,2) + dPhi(2*is-1,2)) / 2
            dErn(is,2) = (dErn(2*is-2,2) + dErn(2*is-1,2)) / 2
            ENDDO 
         DO is = nC4+2, nBL
            dPhi(is,1) = (Phi(2*is-3,1) + 4*Phi(2*is-2,1) + Phi(2*is-1,1)) / 6
            dErn(is,1) = (Ern(2*is-3,1) + 4*Ern(2*is-2,1) + Ern(2*is-1,1)) / 6
            dPhi(is,2) = (Phi(2*is-3,2) + 4*Phi(2*is-2,2) + Phi(2*is-1,2)) / 6
            dErn(is,2) = (Ern(2*is-3,2) + 4*Ern(2*is-2,2) + Ern(2*is-1,2)) / 6
            ENDDO 
         DO is = 2, nBL
            Phi(is,1) = Phi(2*is-1,1)
            Ern(is,1) = Ern(2*is-1,1)
            Phi(is,2) = Phi(2*is-1,2)
            Ern(is,2) = Ern(2*is-1,2)
            ENDDO 
         id = id + 1
         GOTO 100
 199  CONTINUE 

C  Output selection :

      IF     (jfout.eq.1) THEN 
         ! interpolation to experimental grid:
         DO if = 1, nf
            CALL LinIntPolArray (SavX, SavY, nd*(nBL-1)+nCh,
     *                           XF(if), YF(if), 0.d0, Fehler)
            IF (Fehler.ne.'&ff') RETURN
            ENDDO

      ELSEIF (jfout.ge.2 .and. jfout.le.4) THEN 
         ! get Phi(infty)
         Phinfty = 0
         DO is = nBL+1, nCh
            Phinfty = Phinfty + SavY(nd*(nBL-1)+is)
            ENDDO 
         Phinfty = Phinfty / (nCh-nBL)
         Phigma  = 0
         DO is = nBL+1, nCh
            Phigma = Phigma + (SavY(nd*(nBL-1)+is)-Phinfty)**2
            ENDDO 
         Phigma = Phigma / (nCh-nBL)
         IF (Phigma.gt.1d-12) THEN 
            Print *, ' Phi(infty) Phi(sigma) ', Phinfty, Phigma
            CALL NiceNum (Phigma, aux, i2)
            Fehler = 'Phi(t) converges only within +- '//aux(1:i2)
            RETURN 
            ENDIF 
         DO is = 1, (nd+1)*(nBL-1)+1
            SavY(is) = SavY(is) - Phinfty
            ENDDO

         ! blockwise Fourier transform
         DO if = 1, nf
            YF(if) = 0
            ENDDO
         DO id = 0, nd
            n1 = id*(nBL-1)+1
            nn = id*(nBL-1)+nBL
            ht = (SavX(nn) - SavX(n1)) / (nBL-1)
            DO if = 1, nf
               ! lowest-order Filon integration
               theta = XF(if) * ht
               IF (dabs(theta).lt.1d-40) THEN
                  alpha = 1
                  delta = 0
               ELSE
                  alpha = ( dsin(theta/2) / (theta/2) )**2
                  delta = (theta-dsin(theta)) / theta**2
                  ENDIF
               sumY = 0
               IF (jfout.eq.3 .or. jfout.eq.4) THEN ! real part of S(w) = X''/w
                  DO is = n1+1, nn-1
                     sumY = sumY + SavY(is) * dcos(SavX(is)*XF(if))
                     ENDDO ! is
                  sumY = alpha * ( sumY +
     *               ( SavY(n1) * dcos(SavX(n1)*XF(if))
     *               + SavY(nn) * dcos(SavX(nn)*XF(if)) ) / 2 )
     *                    + delta *
     *               ( - SavY(n1) * dsin(SavX(n1)*XF(if))
     *                 + SavY(nn) * dsin(SavX(nn)*XF(if)) )
               ELSEIF (jfout.eq.2) THEN  ! imaginary part of S(w) = X'/w
                  DO is = n1+1, nn-1
                     sumY = sumY + SavY(is) * dsin(SavX(is)*XF(if))
                     ENDDO ! is
                  sumY = alpha * ( sumY +
     *               ( SavY(n1) * dsin(SavX(n1)*XF(if))
     *               + SavY(nn) * dsin(SavX(nn)*XF(if)) ) / 2 )
     *                    + delta *
     *               ( + SavY(n1) * dcos(SavX(n1)*XF(if))
     *                 - SavY(nn) * dcos(SavX(nn)*XF(if)) )
               ELSE 
                  Fehler = 'PROGRAM ERROR / Re vs Im ???'
                  RETURN 
                  ENDIF ! Re vs. Im
               YF(if) = YF(if) + ht * sumY
               ENDDO ! if
            ENDDO ! id

         IF (jfout.eq.2 .or. jfout.eq.3) THEN ! susceptibility
            DO if = 1, nf
               YF(if) = Amp * YF(if) * XF(if) 
                  ! without factor 1/pi: is still in Goetze convention
               ENDDO
         ELSEIF (jfout.eq.4) THEN ! scattering law
            DO if = 1, nf
               YF(if) = Amp * YF(if) * 2 / twopi ! Faktor 1/pi 22okt98
               ENDDO
            IF (GaussW.gt.0) THEN ! add pseudoelastic curve {18jan00}
               DO if = 1, nf
                  YF(if) = YF(if) + ( Amp / dsqrt(twopi/2) / GaussW )
     *                           * Phinfty * dexp (- (XF(if)/GaussW)**2 )
                  ENDDO
               ENDIF
         ELSE
            Fehler = 'Scattering law or susceptibility ?'
            RETURN 
            ENDIF

      ELSE
         Fehler = 'PROGRAM ERROR/ unexpected output choice'
         ENDIF

      END ! MCT_Fit
