using namespace std;

template< class CT >
class Range {
 public:
    CT inf;
    CT sup;

    Range( CT inf_in, CT sup_in ) : inf(inf_in), sup(sup_in) {};
    template<class VT> Range( vector<VT> *V_in );
    string strg() const;
    const char* c_str() const { return strg().c_str(); };
};

typedef Range<double> DblRange;


// implementation:

template<class CT>
template<class VT>
Range<CT>::Range( vector<VT> *V_in )
{
    if( V_in->size()==0 ){
        inf = +1;
        sup = -1;
        return;
    }
    inf = sup = (*V_in)[0];
    for( uint i=1; i<V_in->size(); ++i ){
        inf = min( inf, (*V_in)[i] );
        sup = max( sup, (*V_in)[i] );
    }
}

template<class CT>
string Range<CT>::strg() const
{
    return ::strg(inf) + " .. " + ::strg(sup);
}



