// #include "myexception.h"
#include "workspace.h"


uint Spectrum::size() const
{
    if     ( T[0]->size()==0 )
        return T[1]->size();
    else if( T[0]->size()!=T[1]->size() )
        throw ProgramError( "Spectrum::size discovered inconsistent sizes" );
    else
        return T[0]->size();
}


ValueType DataFile::channelType( uint ixy ) const
{
    if( V.size()==0 )
        return VAL_NON;
    ValueType ret = P_SPEC(V[0])->T[ixy]->vtyp();
    for( uint i=1; i<V.size(); ++i )
        if( P_SPEC(V[i])->T[ixy]->vtyp()!=ret )
            return VAL_MIX;
    return ret;
}

uint DataFile::nT() const
{
    if( V.size()==0 )
        return 0;
    uint ret = P_SPEC(V[0])->size();
    for( uint i=1; i<V.size(); ++i )
        if( P_SPEC(V[i])->size()!=ret )
            return (uint)-1;
    return ret;
}


// WorkFileVector WorkFileVector::restrict( WorkFileType selected_type)
// {
//     WorkFileVector ret;
//     for( uint i=0; i<size(); ++i )
//         if( ((*this)[i])->type()==selected_type )
//             ret.push_back( (*this)[i] );
//     return ret;
// }

void WorkFileIterator::check_styp() {
    if( our_styp==ANY_SLICE ) return; //ok anyway
    for( ; p!=V->end(); p++ )
        if( (**p).styp()!=our_styp )
            throw BadInput(
                strg("file selection contains ") +
                ( (**p).styp()==DATA ? "data" : "curve" ) +
                "file" );
    restart();
};   

bool WorkFileIterator::operator()( WorkFile **ppw ) {
    if( p==V->end() ) return false;
    if( our_styp!=ANY_SLICE && (**p).styp()!=our_styp )
        throw ProgramError( "WorkFileIterator::() inconsistent styp" );
    *ppw = get_pointer( (*(p++)) );
    return true; };

bool WorkFileIterator::operator()( DataFile **ppwd ) {
    WorkFile *pw;
    bool ret = operator()( &pw );
    if( ret )
        *ppwd = (DataFile*)pw;
    return ret;
};
