class CCoord {
 public:
    string name, unit;

    inline CCoord() {};
    inline CCoord( const string _name, const string _unit) :
        name(_name), unit(_unit) {};

    CCoord Ask( const string& quest, const CCoord& defval );
    CCoord Ask( const string& quest );

    friend ostream& operator<< (ostream &s, CCoord C);
    string str() const;
    string ps_str() const;
    string to_a01() const;
    inline bool defined(void) { return name!=""; };
    string load_a01(string);

    inline bool operator== (const CCoord& Co2) const { 
        return (name==Co2.name) && (unit==Co2.unit); };
    inline bool operator!= (const CCoord& Co2) const {
        return !(*this==Co2); };

 private:
    static const char *helptext;
};

inline string strg(const CCoord& C) { return C.str(); };

class CParam {
 public:
    CCoord Co;
    double val;

    inline CParam() {};
    inline CParam(CCoord Cin, double vin=0) { Co = Cin; val = vin; };
    inline CParam(string _name, string _unit="", double vin=0) 
        { Co = CCoord(_name, _unit); val = vin; };

    string str(void) const;
};

